<!DOCTYPE html>
<html>

<head>
<title>WebAuthn checker - W3C WD-07 Mode</title>
<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.2/jquery.min.js"></script>
<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.2/jquery.min.js"></script>
<script type="text/javascript" src="./base64.js"></script>
<script type="text/javascript" src="./pkijs/common.js"></script>
<script type="text/javascript" src="./pkijs/asn1.js"></script>
<script type="text/javascript" src="./pkijs/x509_schema.js"></script>
<script type="text/javascript" src="./pkijs/x509_simpl.js"></script>
<script type="text/javascript" src="./cbor.js"></script>
<script type="text/javascript" src="https://id1.vx4.eu/fidelio/js/fidelio.js"></script>
<script type="text/javascript" src="driver.js"></script>
<style>
* {
  margin: 0;
  padding: 0;
}

body {
  text-align: left;
  font-size: 10pt;
  font-family: system, Helvetica, sans-serif;
}

#container {
  width: 600px;
  margin: 0 auto;
  margin-top: 1em;
}

#error {
  font-size: 150%;
  font-weight: bold;
  text-align: center;
}

.row {
  margin-top: 1em;
  margin-bottom: 1em;
}
.row ol {
  margin-left: 2em;
}

.box {
  border: 1px solid grey;
  padding: 3px;
  margin-bottom: 10px;
}
.subtitle {
  font-style: italic;
}

button {
  background-color: black;
  color: white;
  border: 1px solid black;
  padding: 1ex;
  width: 100%;
}

button:active {
  background-color: #303;
}

input {
  margin-bottom: 20px;
}

pre {
  width: 560px;
  height: 20em;
  overflow: scroll;
  background-color: #eee;
  border: 1px solid #999;
  margin: 1em 0;
}

.inactive {
  background-color: #999;
}

.success {
  background-color: #dfd;
}

.todo {
  background-color: #dff;
}

.failure {
  background-color: #fdd;
}
</style>
</head>

<body>
<div id="container">
 <div class="row">
  <p><strong>This is the W3C attestation mode checker. It's a <big>work-in-progress</big>.</strong> Other checkers available:</p>
  <ol>
   <li><a href="/origin">RPID is Origin w/ Firefox attestation mode (<strong>Firefox 55</strong>)</a></li>
   <li><a href="/domainstring">RPID is Domain String w/ Firefox attestation mode (<strong>Historical anomaly</strong>)</a></li>
   <li><a href="/wd-05">WD-05 Mode (<strong>Firefox 56</strong>)</a></li>
  </ol>
  <p>This one uses <strong>WD-05</strong> <a href="http://cbor.me/">CBOR encoding</a> and the FIDO U2F Attestation Mode and is intended for <strong>Firefox 56</strong>.</p>
 </div>
 <div class="row">
  <p>To use this to test Web Authentication support in Firefox, do the following:</p>
  <ol>
   <li>Open the Firefox advanced preferences in <a href="about:config">about:config</a>.</li>
   <li>Search for "webauth"</li>
   <li>Enable (value=True) these two:
    <ul>
      <li><tt>security.webauth.webauthn</tt></li>
      <li><tt>security.webauth.webauthn_enable_softtoken</tt></li>
    </ul>
   </li>
   <li>Reload this page and click buttons!</li>
  </ol>
 </div>

 <div class="row">
  <p id="error"></p>

  <!-- registration -->
  <div class="box">
    <button id="createButton">Create Credential</button>
    <pre id="createOut"></pre>
  </div>

  <!-- sign -->
  <div class="box">
    <button id="getButton">Get Assertion</button>
    <pre id="getOut"></pre>
  </div>

  <div class="box">
    <p class="subtitle">Advanced</p>
    <p>Relying Party ID to use. "<tt>bin.coffee</tt>" and "<tt>webauthn.bin.coffee</tt>" should be the only valid options.</p>
    <input id="rpIdText" type="text" size="50"/>
  </div>

 </div>
</div>
</body>
</html>
